function interacting(interacter, switch, switch_name)
  toggle_electricity(switch)
  toggle_switch_sprite(switch)

  GameEntityPlaySound(switch, "player_projectiles/critical_hit" )
end

function toggle_switch_sprite(switch)
  local offSpriteComp = EntityGetFirstComponentIncludingDisabled(switch, "SpriteComponent", "switch_off")
  local onSpriteComp = EntityGetFirstComponentIncludingDisabled(switch, "SpriteComponent", "switch_on")

  local is_on = ComponentGetIsEnabled(onSpriteComp)

  EntitySetComponentIsEnabled(switch, offSpriteComp, is_on)
  EntitySetComponentIsEnabled(switch, onSpriteComp, not is_on)
end

function toggle_electricity(switch)
  local pos_x, pos_y = EntityGetTransform(switch)
  local fan = EntityGetClosestWithTag(pos_x, pos_y, "fan2")
  
	local variable_storage = EntityGetComponent(fan, "VariableStorageComponent")

	for k, v in pairs(variable_storage)do
		local name = ComponentGetValue2(v, "name")

		if(name == "power")then
			power = ComponentGetValue2(v, "value_bool") 
			ComponentSetValue2( v, "value_bool", not power )
		end
	end

end
