dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local number = GetValueNumber("number", 0)
SetValueNumber("number", number + 1)

if number == 200 and not loaded_credits then
  loaded_credits = true
  GameAddFlagRun("ending_game_completed")
  EntityLoad("mods/koira/files/enemies/the_dog/fake_credits.xml")
end

if number >= 200 then
  local value = ( number - 200 ) * 0.005
  GameSetPostFxParameter("overlay_color_blindness_ending", 0, 0, 0, value)
end

if number == 400 and not killed_player then
	local dog = EntityGetWithTag("dog")[1]
	EntitySetComponentsWithTagEnabled(dog, "love", false)
	local black = EntityCreateNew()
	EntitySetTransform(black, x, y)
	EntityAddComponent(black, "SpriteComponent", {
		image_file="mods/koira/files/enemies/the_dog/black.png" ,
		offset_x="256",
		offset_y="256",
		z_index="-5"
	} )
  killed_player = true
  GameOnCompleted()
  EntityKill(entity_id)
end
local ritual_complete = GlobalsGetValue("koira_ritual_complete", "0") == "1"
if not ritual_complete then
	if GameGetFrameNum() % 10 == 0 then
		SetRandomSeed( GameGetFrameNum(), x + y + entity_id )
		
		local colors = { "green" , "blue", "pink", "orange" }
		shoot_projectile(entity_id, "mods/koira/files/fireworks/firework_" .. colors[Random(1, #colors)] .. ".xml", x + Random(-200, 200), y, Random(-5, 5), Random(-100, -150))
	end
end