dofile_once("mods/koira/files/scripts/utilities.lua")
dofile_once("mods/koira/files/scripts/gun_utilities.lua")


function pixel_scene_loader(biome_path)
  -- TODO: Mark a global variable that the scene is loaded for biome_path
  return function(filename, x, y, skip_biome_checks, skip_edge_textures, color_table, bg_z_index)
    -- if GlobalGetValue(biome_path) == "LOADED" then
    --   return
    -- end

    local path = MOD_PATH .. biome_path
    LoadPixelScene(
      path .. filename .. ".png",
      path .. filename .. "_visual.png",
      x, y,
      path .. filename .. "_background.png",
      skip_biome_checks,
      skip_edge_textures,
      color_table,
      bg_z_index
    )
    --GlobalSetValue(biome_path, "LOADED");
  end
end


function load_biome_scene(name, x, y, skip_biome_checks, skip_edge_textures, color_table, bg_z_index)
  local path = MOD_PATH .. "biomes/" .. name .. "/" .. name
  LoadPixelScene(
    path .. ".png",
    path .. "_visual.png",
    x, y,
    path .. "_background.png",
    skip_biome_checks,
    skip_edge_textures,
    color_table,
    bg_z_index
  )
end


function enemy_entity_path(name)
  return MOD_PATH .. "enemies/" .. name .. "/animal.xml"
end


function spawn_enemy(name, x, y)
  EntityLoad(enemy_entity_path(name), x, y)
end

