dofile_once("mods/koira/files/scripts/gun_utilities.lua")


function throw_item(from_x, from_y, to_x, to_y)
  local fists = EntityGetWithName("fists")
  local weapon = GetUpdatedEntityID()

  local fists_being_thrown_away = (fists == weapon)
  local guns = get_gun_count()


  -- Fists themselves are being thrown away, don't leave them lying on the ground.
  if fists_being_thrown_away then
    EntityKill(fists)
  end

  -- Give fists when the player throws away the last weapon.
  if guns == 0 then
    give_player_gun("fists")
  end

  -- Code for trying to always keep fists in the inventory. Scrapped for now.
  -- Really messy detection logic and probably not worth the effort for the player.
  --
  -- local no_fists = (fists == nil or fists == 0)
  --
  -- if guns == 1 and no_fists then
  --   -- Do nothing
  -- end
  --
  -- if guns == 3 and not fists_being_thrown_away and no_fists then
  --   give_player_gun("fists")
  -- end

  -- if guns < 3 and fists_being_thrown_away then
  --   give_player_gun("fists")
  -- end
end
