dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/koira/files/scripts/utilities.lua")


-- This is a bit unfortunate hack, but the best we can do right now
local KNIFE_CONFIG = {
    ["attach_to_surfaces_knife_style"] = 1,
    ["attach_min_speed"] = 20,
    ["throw_force_coeff"] = 1.55,
    ["max_throw_speed"] = 280,
    ["min_torque"] = 0.1,
    ["max_torque"] = 2,
}

local GUN_CONFIG = {
    ["max_throw_speed"] = 190,
}


function enable_weapon_throwing(gun)
  local abilityComponent = EntityGetFirstComponentIncludingDisabled(gun, "AbilityComponent")
  local throwComponent = EntityGetFirstComponentIncludingDisabled(gun, "PhysicsThrowableComponent")

  ComponentSetValue2(abilityComponent, "throw_as_item", true)
  if throwComponent == nil then
    local throw_config = EntityHasTag(gun, "knife_style") and KNIFE_CONFIG or GUN_CONFIG

    EntityAddComponent(gun, "PhysicsThrowableComponent", throw_config)
  end
end


function disable_weapon_throwing(gun)
  local abilityComponent = EntityGetFirstComponentIncludingDisabled(gun, "AbilityComponent")
  local throwComponent = EntityGetFirstComponentIncludingDisabled(gun, "PhysicsThrowableComponent")

  ComponentSetValue2(abilityComponent, "throw_as_item", false)
  EntityRemoveComponent(gun, throwComponent)
end



--
-- trigger function
--
function item_pickup(entity_item, entity_pickupper, item_name )
  -- Make sure the gun doesn't get stuck in throwing mode if we faceroll
  -- on the keyboard when throwing it away initially.
  disable_weapon_throwing(entity_item)
end
