if GlobalsGetValue("koira_sleeping_complete_times", "0") == "0" then

	local min_heatwarp_at_x = 1510
	local max_heatwarp_at_x = 3500

	local player = EntityGetWithTag("player_unit")[1]
	if player then
	  local x, y = EntityGetTransform(player)
	  if x > min_heatwarp_at_x then
		local heat_warp_amount = math.min(1, math.max(0, (min_heatwarp_at_x - x) / (min_heatwarp_at_x - max_heatwarp_at_x)))
		GameSetPostFxParameter("overlay_color_blindness", 0, 0, 0, heat_warp_amount)
			
		if x > 1600 then
			local dataComp = EntityGetFirstComponent(player, "CharacterDataComponent")
			local vel_x, vel_y = ComponentGetValue2( dataComp, "mVelocity" )
			ComponentSetValueVector2(dataComp, "mVelocity", -35, vel_y)
			-- ComponentSetValue2(dataComp, "is_on_ground", true)

			local sleep_effect_applied = GlobalsGetValue("koira_zzz_done", "0") == "1"
			if not sleep_effect_applied then
			  GlobalsSetValue("koira_zzz_done", "1")
			  local effect_entity = EntityLoad("mods/koira/files/statuses/sleep/effect.xml", x, y)
			  EntityAddChild(player, effect_entity)
			end
		end
		
	  end
		
	end

end