CURRENTLY IMPLEMENTED FEATURES
==============================

## Character

- New player spritesheet: Hank
- Can't fly, but can still swim and do all other basic actions
- Can doublejump and dash (jump-kick)


## Guns

- Implemented with care for best immersion
  - Proper feedback and just the right amount of gore is configured for each gun
  - Energy weapons turn enemies to ashes

- Multiple weapon types:
  - Normal: Pistol, Revolver, Shotgun, SMG, Bolt-action Rifle, Assault Rifle
  - Dangerous: Flammenwerfer, Rocket Launcher, Grenade Launcher, The Stakler
  - Energy: Plasmagun, Railgun, Lightning Gun
  - Melee: fists, knife

- Weapon crate for each different weapon type, to find guns in

- All weapons are throwable physics objects (except for fists)
- Custom animation for melee
- Any weapon can be given a laser sight
- Rewritten proper ammo system:
  - Each "action" (from base game) is a magazine
  - Magazines are tied to weapons
  - Uses only the base UI, no distracting overlays
  - Autopickup weapon ammunition, and autoplace it in the correct gun.
- Custom ammo system works 100% parallel with the base Noita wand-spell system.
- Easy creation of new guns with custom base template
- HUD warnings for: Low ammo, last magazine & empty gun

- Shrapnel grenade with real individual shrapnels on explosion


## Enemies

- New:
  - Cacodemon
  - Bat (sprite by @kh)
  - Dog (sprite by @kh)
  - Alpha sheep (sprite by @Avis⁷)
  - Shepherd, Lumberjack & Shotgunner recolors (sprites by @Avis⁷)

- Adapted from base game:
  - "The Nope" (from lukki-longleg)
  - Haulikkohiisi

- A lot of different hiisi and monsters planned


## Other

- New "story"
- Entirely new biome_map.png
  - Multiple custom biomes in the works

- The best dog AI in any video game ever

- Custom "rage" gameplay element
  - Rage that keeps bottling up on every kill
  - Can be used to invoke the "berserk" effect
  - Custom black & white shader effect, with red filter

- Most in-game UI element texts changed, for better thematic fit
