function interacting(interacter, switch, switch_name)
  toggle_switch_sprite(switch)
  local pos_x, pos_y = EntityGetTransform(switch)
  LoadPixelScene("mods/koira/files/biomes/objects/cover/pixel_clear.png", "", pos_x - 220, pos_y + 24, "", true)
  LoadPixelScene("mods/koira/files/biomes/objects/cover/pixel.png", "mods/koira/files/biomes/objects/cover/pixel_visual.png", pos_x - 220, pos_y + 25, "", true)
  GameEntityPlaySound(switch, "player_projectiles/critical_hit" )
  local interactable_component = EntityGetFirstComponentIncludingDisabled(switch, "InteractableComponent")
  EntitySetComponentIsEnabled(switch, interactable_component, false)
  local this_component = GetUpdatedComponentID()
  EntityRemoveComponent( switch, this_component )
end

function toggle_switch_sprite(switch)
  local offSpriteComp = EntityGetFirstComponentIncludingDisabled(switch, "SpriteComponent", "switch_off")
  local onSpriteComp = EntityGetFirstComponentIncludingDisabled(switch, "SpriteComponent", "switch_on")

  local is_on = ComponentGetIsEnabled(onSpriteComp)

  EntitySetComponentIsEnabled(switch, offSpriteComp, is_on)
  EntitySetComponentIsEnabled(switch, onSpriteComp, not is_on)
end