dofile_once("mods/koira/lib/coroutines.lua")
dofile_once("mods/koira/files/util.lua")
dofile_once("mods/koira/files/camera.lua")
dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local character_data_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
ComponentSetValue2(character_data_component, "mVelocity", -35, 0)
ComponentSetValue2(character_data_component, "is_on_ground", true)

local controls_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")
ComponentSetValue2(controls_component, "mAimingVector", 1, 0)
ComponentSetValue2(controls_component, "mAimingVectorNormalized", -5000, 0)
ComponentSetValue2(controls_component, "mAimingVectorNonZeroLatest", -5000, 0)
ComponentSetValue2(controls_component, "mMousePosition", -5000, 0)

