STOPPED_SCALING = false
HAS_DOUBLE_JUMPED = false
HAS_DASHED = false

PREV_KICK = false
PREV_USE = false

PREV_FRAMES_SWIMMING = 0
PREV_FRAMES_IN_AIR = 0


-- Doggy things
DoNothing      = 0
FollowBone     = 1
BringBone      = 2
WaitForThrow   = 3

DOG_STATE = DoNothing


-- Blood altar
BeforeNightmares = "0"
AfterNightmares  = "1"
WithKnife        = "2"
Suffering        = "3"

SUFFER_COUNT = 0


-- Respawn and teleport locations
SpawnBed = "bed"
SpawnHiidenkivi = "kivi"
SpawnHiidenkiuas = "kiuas"
SpawnHiidenkirnu = "kirnu"
SpawnPirunpelto = "pelto"
SpawnFactory = "factory"
SpawnFactoryOut = "factoryout"
SpawnJungle = "jungle"
SpawnMountain = "mountain"
SpawnFarm = "farm"

-- Nightmare teleport locations
NightmareTP1 = "first_nightmare"
NightmareTP2 = "second_nightmare"

-- Globals keys
CURRENT_SPAWN = "where should we spawn"
ALTAR_STATE = "what should the altar do"

TELEPORT_LOCATIONS = {
  [SpawnBed] = {1365, 45},
  [SpawnHiidenkivi] = {3188, 104},
  [NightmareTP1] = {-3638, 754},
  [NightmareTP2] = {-1746, 674},
  [SpawnFactory] = {23706, 133},
  [SpawnFactoryOut] = {29562, 152},
  [SpawnJungle] = {30873, 190},
  [SpawnMountain] = {35192, -645},
  [SpawnFarm] = {16000, 100}
}

function LOCATION(loc)
  return unpack(TELEPORT_LOCATIONS[loc])
end
